src/Entity/User.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\ORM\Mapping\Table;
use Doctrine\ORM\Mapping\UniqueConstraint;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\EquatableInterface;
use Symfony\Component\Security\Core\User\UserInterface;

/**
 * @ORM\Entity(repositoryClass="App\Repository\UserRepository")
 * @UniqueEntity("email")
 * @UniqueEntity("name")
 * @Table(
 *     name="`user`",
 *     uniqueConstraints={
 *         @UniqueConstraint(name="email_unique",columns={"email"}),
 *         @UniqueConstraint(name="user_name_unique",columns={"name"})
 *     }
 * )
 */
class User implements UserInterface, EquatableInterface
{

    const ROLE_USER      =  0;
    const ROLE_ORACLE    =  2;
    const ROLE_CROW      =  3;
    const ROLE_ADMIN     =  4;

    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=16)
     */
    private $name;

    /**
     * @ORM\Column(type="string", length=190)
     */
    private $email;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $pass;

    /**
     * @ORM\Column(type="boolean")
     */
    private $validated;

    /**
     * @ORM\OneToOne(targetEntity="App\Entity\UserPendingValidation", mappedBy="user", cascade={"persist", "remove"})
     */
    private $pendingValidation;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Citizen", mappedBy="user")
     */
    private $citizens;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\AdminBan", mappedBy="user")
     */
    private $bannings;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\FoundRolePlayText", mappedBy="user")
     */
    private $foundTexts;

    /**
     * @ORM\Column(type="integer")
     */
    private $soulPoints = 0;
    
    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Picto", mappedBy="user", cascade={"persist", "remove"})
     */
    private $pictos;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Award", mappedBy="user")
     */
    private $awards;

    /**
     * @ORM\Column(type="string", length=32)
     */
    private $externalId = '';

    /**
     * @ORM\OneToOne(targetEntity="App\Entity\Avatar", cascade={"persist", "remove"})
     */
    private $avatar;

    /**
     * @ORM\Column(type="boolean")
     */
    private $preferSmallAvatars = false;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $postAsDefault;

    /**
     * @ORM\Column(type="string", length=128, nullable=true)
     */
    private $forumTitle;

    /**
     * This field matches to the filename of the picto
     * @ORM\Column(type="string", length=64, nullable=true)
     */
    private $forumIcon;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $language = null;

    /**
     * @ORM\Column(type="smallint")
     */
    private $rightsElevation = 0;

    /**
     * @ORM\OneToMany(targetEntity=CitizenRankingProxy::class, mappedBy="user", orphanRemoval=true)
     */
    private $pastLifes;

    /**
     * @ORM\Column(type="integer")
     */
    private $heroDaysSpent = 0;

    public function __construct()
    {
        $this->citizens = new ArrayCollection();
        $this->foundTexts = new ArrayCollection();
        $this->pictos = new ArrayCollection();
        $this->bannings = new ArrayCollection();
        $this->pastLifes = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getUsername(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getForumIcon(): ?string {
        return $this->forumIcon;
    }

    public function setForumIcon(string $value): self {
        $this->forumIcon = $value;

        return $this;
    }

    public function getForumTitle(): ?string {
        return $this->forumTitle;
    }

    public function setForumTitle(string $value): self {
        $this->forumTitle = $value;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    public function getSalt( ): string {
        return 'user_salt_myhordes_ffee45';
    }

    /**
     * @return Collection|AdminBan[]
     */
    public function getBannings(): Collection
    {
        return $this->bannings;
    }

    public function getValidated(): ?bool
    {
        return $this->validated;
    }

    public function setValidated(bool $validated): self
    {
        $this->validated = $validated;

        return $this;
    }

    public function getPendingValidation(): ?UserPendingValidation
    {
        return $this->pendingValidation;
    }

    public function setPendingValidation(?UserPendingValidation $pendingValidation): self
    {
        $this->pendingValidation = $pendingValidation;

        // set (or unset) the owning side of the relation if necessary
        $newUser = null === $pendingValidation ? null : $this;
        if ($pendingValidation && $pendingValidation->getUser() !== $newUser) {
            $pendingValidation->setUser($newUser);
        }

        return $this;
    }

    /**
     * @inheritDoc
     */
    public function getRoles()
    {
        $roles = [];
        if ($this->pass === null) return $roles;
        if ($this->rightsElevation >= 4) $roles[] = 'ROLE_ADMIN';
        if ($this->rightsElevation >= 3) $roles[] = 'ROLE_CROW';
        if ($this->rightsElevation >= 2) $roles[] = 'ROLE_ORACLE';
        if (strstr($this->email, "@localhost") === "@localhost") $roles[] = 'ROLE_DUMMY';
        if ($this->validated) $roles[] = 'ROLE_USER';
        else $roles[] = 'ROLE_REGISTERED';
        if ($this->getIsBanned()) $roles[] = 'ROLE_BANNED';
        return $roles;
    }

    /**
     * @inheritDoc
     */
    public function getPassword()
    {
        return $this->pass;
    }

    public function setPassword(?string $pass): self {
        $this->pass = $pass;
        return $this;
    }

    /**
     * @inheritDoc
     */
    public function eraseCredentials() {}

    /**
     * @inheritDoc
     */
    public function isEqualTo(UserInterface $user) {
        $b1 = $this->getPassword() !== null && $user->getPassword() !== null &&
            $this->getUsername() === $user->getUsername() &&
            $this->getPassword() === $user->getPassword() &&
            $this->getRoles() === $user->getRoles();
        if ($user instanceof User) {
            return $b1 &&
                $this->getRightsElevation() === $user->getRightsElevation();
        } else return $b1;
    }

    public function getIsBanned(): bool {
        foreach ($this->getBannings() as $b)
            if ($b->getActive())
                return true;
        return false;
    }

    public function getLongestActiveBan(): ?AdminBan {
        $ban = null;
        foreach ($this->getBannings() as $b){
            if ($b->getActive()) {
                if (!isset($ban)) {
                    $ban = $b;                       
                }
                else if ($b->getBanEnd() > $ban->getBanEnd())
                    $ban = $b;     
            }
        }            
        if (isset($ban))
            return $ban;
        return null;
    }

    /**
     * @return Collection|AdminBan[]
     */
    public function getActiveBans(): Collection {
        $bans = $this->getBannings();
        foreach ($bans as $ban){
                if (!($ban->getActive()))
                    $bans->remove($ban->getId());  
            }            
        return $bans;
    }

    public function getActiveCitizen(): ?Citizen {
        foreach ($this->getCitizens() as $c)
            if ($c->getActive())
                return $c;
        return null;
    }

    public function getAliveCitizen(): ?Citizen {
        foreach ($this->getCitizens() as $c)
            if ($c->getAlive())
                return $c;
        return null;
    }

    /**
     * @return Collection|Citizen[]
     */
    public function getCitizens(): Collection
    {
        return $this->citizens;
    }

    public function addCitizen(Citizen $citizen): self
    {
        if (!$this->citizens->contains($citizen)) {
            $this->citizens[] = $citizen;
            $citizen->setUser($this);
        }

        return $this;
    }

    public function removeCitizen(Citizen $citizen): self
    {
        if ($this->citizens->contains($citizen)) {
            $this->citizens->removeElement($citizen);
            // set the owning side to null (unless already changed)
            if ($citizen->getUser() === $this) {
                $citizen->setUser(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|RolePlayText[]
     */
    public function getFoundTexts(): Collection
    {
        return $this->foundTexts;
    }

    public function addFoundText(RolePlayText $foundText): self
    {
        if (!$this->foundTexts->contains($foundText)) {
            $this->foundTexts[] = $foundText;
        }

        return $this;
    }

    public function removeFoundText(RolePlayText $foundText): self
    {
        if ($this->foundTexts->contains($foundText)) {
            $this->foundTexts->removeElement($foundText);
        }

        return $this;
    }

    public function getSoulPoints(): ?int
    {
        return $this->soulPoints;
    }

    public function setSoulPoints(int $soulPoints): self
    {
        $this->soulPoints = $soulPoints;

        return $this;
    }

    public function addSoulPoints(int $soulPoints): self
    {
        $this->soulPoints += $soulPoints;

templates/ajax/admin/users/account.html.twig
{% extends "ajax/ajax.html.twig" %}
{% block ajax %}
    {# @var user \App\Entity\User#}
    <div class="row soul">
        <div class="cell padded header rw-12">
            {% embed "ajax/admin/users/tabs.html.twig" %}{% endembed %}
            <div class="row">
                <div class="cell padded rw-3 rw-sm-12">
                    <b>{{ 'Benutzername'|trans({}, 'admin') }}</b>
                </div>
                <div class="cell padded rw-9 rw-sm-12">
                    {{ user.username }}
                </div>

                {% if is_granted("ROLE_ADMIN") %}
                    <div class="cell padded rw-3 rw-sm-12">
                        <b>{{ 'E-Mail'|trans({}, 'admin') }}</b>
                    </div>
                    <div class="cell padded rw-9 rw-sm-12">
                        {{ user.email }}
                    </div>
                {% endif %}

                <div class="cell padded rw-3 rw-sm-12">
                    <b>{{ 'Validiert'|trans({}, 'admin') }}</b>
                </div>
                <div class="cell padded rw-9 rw-sm-12">
                    {% if user.validated %}{{ 'Ja'|trans({}, 'admin') }}{% else %}{{ 'Nein'|trans({}, 'admin') }}{% endif %}
                </div>

                <div class="cell padded rw-3 rw-sm-12">
                    <b>{{ 'Berechtigungsstufe'|trans({}, 'admin') }}</b>
                </div>
                <div class="cell padded rw-9 rw-sm-12">
                    {% if     user.rightsElevation == 0 %} {{ 'Spieler'|trans({}, 'admin') }}
                    {% elseif user.rightsElevation == 3 %} {{ 'Krähe'|trans({}, 'admin') }}
                    {% elseif user.rightsElevation == 4 %} {{ 'Admin'|trans({}, 'admin') }}
                    {% else                             %} {{ user.rightsElevation }} {% endif %}
                </div>

                {% if is_granted("ROLE_ADMIN") %}
                    <div class="cell padded rw-3 rw-sm-12">
                        <b>{{ 'Validierungstokens'|trans({}, 'admin') }}</b>
                    </div>
                    <div class="cell padded rw-9 rw-sm-12">
                        {% if validations|length == 0 %}{{ 'Keine'|trans({}, 'admin') }}{% endif %}
                        {% for token in validations %}
                            {# @var token \App\Entity\UserPendingValidation #}
                            <div>{{ token.pkey }}
                                ({% if     token.type ==  constant('App\\Entity\\UserPendingValidation::EMailValidation') %} EMailValidation
                                {% elseif token.type ==  constant('App\\Entity\\UserPendingValidation::ResetValidation') %} ResetValidation
                                {% else                                                                                  %} {{ token.type }} {% endif %})
                                <div x-delete-token="{{ token.id }}" class="button small inline"><i class="fa fa-trash"></i></div>
                            </div>
                        {% endfor %}
                    </div>
                {% endif %}

                <div class="cell padded rw-3 rw-sm-12">
                    <b><label for="administer-user">{{ 'User administrieren'|trans({}, 'admin') }}</label></b>
                </div>
                <div class="cell padded rw-9 rw-sm-12">
                    <select id="administer-user">
                        <option value="">-</option>
                        <optgroup label="{{ 'Validierung'|trans({},'admin') }}">
                            {% if is_granted("ROLE_ADMIN") %}
                                {% if user.validated %}
                                    <option value="{{ url('admin_users_account_manage', {action: 'invalidate', id: user.id}) }}">{{ 'Erneute Validierung erzwingen'|trans({},'admin') }}</option>
                                {% else %}
                                    <option value="{{ url('admin_users_account_manage', {action: 'validate', id: user.id}) }}">{{ 'Manuell validieren'|trans({},'admin') }}</option>
                                {% endif %}
                            {% endif %}
                            {% if not is_granted("ROLE_ADMIN") or validations|length > 0 %}
                                <option value="{{ url('admin_users_account_manage', {action: 'refresh_tokens', id: user.id}) }}">{{ 'Offene Token erneut ankündigen'|trans({},'admin') }}</option>
                                <option value="{{ url('admin_users_account_manage', {action: 'regen_tokens', id: user.id}) }}">{{ 'Offene Token regenerieren'|trans({},'admin') }}</option>
                            {% endif %}
                        </optgroup>
                        {% if is_granted("ROLE_ADMIN") %}
                            <optgroup label="{{ 'Sicherheit'|trans({},'admin') }}">
                                <option value="{{ url('admin_users_account_manage', {action: 'initiate_pw_reset', id: user.id}) }}">{{ 'Passwort-Reset auslösen'|trans({},'admin') }}</option>
                                <option value="{{ url('admin_users_account_manage', {action: 'enforce_pw_reset', id: user.id}) }}">{{ 'Passwort-Reset erzwingen'|trans({},'admin') }}</option>
                            </optgroup>
                        {% endif %}
                    </select>
                    <div id="execute_button" class="button inline small">{{ 'Ausführen'|trans({},'admin') }}</div>
                </div>
            </div>
        </div>
    </div>
    {% embed "ajax/admin/users/footer.html.twig" %}{% endembed %}
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>
        document.getElementById('execute_button').addEventListener('click', function() {
            if (!document.getElementById('administer-user').value) return;
            $.ajax.easySend( document.getElementById('administer-user').value, {},
                function () {
                    $.ajax.load(null, '{{ path('admin_users_account_view', {id: user.id}) }}', true);
                } );
        });

        {% if is_granted("ROLE_ADMIN") %}
            $.html.addEventListenerAll('[x-delete-token]', 'click', function(e,elem) {
                $.ajax.easySend( '{{ path('admin_users_account_manage', {id: user.id, action: 'delete_token'}) }}', {tid: elem.getAttribute('x-delete-token')},
                    function () {
                        $.ajax.load(null, '{{ path('admin_users_account_view', {id: user.id}) }}', true);
                    } );
            });
        {% endif %}
    </script>
{% endblock %}

templates/ajax/admin/users/ban.html.twig
{% extends "ajax/ajax.html.twig" %}
{% block ajax %}
    <div class="row soul">
        <div class="cell padded header rw-12">
            {% embed "ajax/admin/users/tabs.html.twig" %}{% endembed %}
            <div class="row">
                <div class="cell padded rw-3 rw-sm-12">
                    {{ 'Status'|trans({}, 'admin') }}
                </div>
                <div class="cell padded rw-5 rw-sm-12">
                    <input disabled style="width: 25em;" value="{% if banned %}{{ 'Verbannt bis '|trans({}, 'admin') }}{{ activeBan.banEnd|date('d.m.Y h:i:s') }}{% else %}{{ "--" }}{% endif %}" />
                </div>
                {% if banned %}
                <div class="cell padded rw-2 rw-sm-12">
                    <button id="x-lift-ban">{{ 'Aufheben'|trans({}, 'admin') }}</button>
                </div>
                {% endif %}
            </div>
            <div class="row">
                <div class="cell padded rw-3 rw-sm-12">
                    {{ 'Letzte Verbannung'|trans({}, 'admin') }}
                </div>
                <div class="cell padded rw-5 rw-sm-12">
                    <input disabled style="width: 25em;" value="{% if banCount > 0 %}{{ lastBan.banStart|date('d.m.Y') }} -- {{ 'Verbannungen'|trans({}, 'admin') }}: {{ banCount }}{% else %}{{ "--" }}{% endif %}" />
                </div>
            </div>
            <div class="row">
                <div class="cell padded rw-3 rw-sm-12">
                    {{ 'Verbannen'|trans({}, 'admin') }}
                </div>
                <div class="cell padded rw-5 rw-sm-12">
                    <select name="duration" id="ban-duration">
                        <optgroup label={{ 'Dauer'|trans({}, 'admin') }}>
                            <option value="1">{{ '1 Tag'|trans({}, 'admin') }}</option>
                            <option value="3">{{ '3 Tage'|trans({}, 'admin') }}</option>
                            <option value="5">{{ '5 Tage'|trans({}, 'admin') }}</option>
                            <option value="7">{{ '7 Tage'|trans({}, 'admin') }}</option>
                            <option value="15">{{ '15 Tage'|trans({}, 'admin') }}</option>
                            <option value="30">{{ '30 Tage'|trans({}, 'admin') }}</option>
                        </optgroup>
                    </select>
                </div>
                <div class="row">
                    <div class="cell padded ro-2 rw-1 rw-sm-12">
                        {{ 'Grund'|trans({}, 'admin') }}
                    </div>
                    <div class="cell padded rw-5 rw-sm-12">
                        <textarea id="ban-reason"></textarea>                       
                    </div>
                </div>
                <div class="row">               
                    <div class="cell padded ro-3 rw-5 rw-sm-12">
                        <button id="x-confirm-ban">{{ 'Verbannen'|trans({}, 'admin') }}</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    {% embed "ajax/admin/users/footer.html.twig" %}{% endembed %}
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>
            document.getElementById('x-confirm-ban').addEventListener('click', function(e) {
            e.preventDefault();
            let target_payload = {                
                duration: document.getElementById('ban-duration').value,
                reason: document.getElementById('ban-reason').value,
            };

            $.ajax.easySend( '{{ path('admin_users_ban', { 'id': user.Id }) }}', target_payload,
                function () {
                    $.ajax.load(null, '{{ path('admin_users_ban_view', { 'id': user.Id }) }}', true);
                } )
        });
        {% if banned %}
        document.getElementById('x-lift-ban').addEventListener('click', function(e) {
            e.preventDefault();
            
            $.ajax.easySend( '{{ path('admin_users_ban_lift', { 'id': user.Id }) }}', [],
                function () {
                    $.ajax.load(null, '{{ path('admin_users_ban_view', { 'id': user.Id }) }}', true);
                } )
        });
        {% endif %}
    </script>
{% endblock %}

templates/ajax/admin/users/citizen.html.twig
{% extends "ajax/ajax.html.twig" %}
{% block ajax %}
    <div class="row soul">
        <div class="cell padded header rw-12">
            {% embed "ajax/admin/users/tabs.html.twig" %}{% endembed %}

            <div class="row">
                <div class="cell rw-8 ro-2">
                    <div class="row">
                        <div class="cell padded rw-12">
                            {{ 'Derzeitiges Leben'|trans({}, 'admin') }}
                        </div>
                        <div class="cell padded rw-12">
                            <input disabled style="width: 25em;" value="{% if active %}{{ town.name }}{% if not alive %}{{ " -- " }}{{ 'TOD NICHT BESTÄTIGT'|trans({}, 'admin') }}{% endif %}{% else %}{{ "--" }}{% endif %}" />
                        </div>
                        {% if active %}
                            {% if alive %}
                                <div class="cell padded rw-4">
                                    <button id="x-headshot">{{ 'Kopfschuss'|trans({}, 'admin') }}</button>
                                </div>
                                <div class="cell padded rw-4">
                                    <button id="x-pm">{{ 'PM vom Raben'|trans({}, 'admin') }}</button>
                                </div>
                            {% else %}
                                {% if is_granted("ROLE_ADMIN") %}
                                    <div class="cell padded rw-4">
                                        <button id="x-confirm-death">{{ 'Tod bestätigen'|trans({}, 'admin') }}</button>
                                    </div>
                                {% endif %}
                            {% endif %}
                        {% endif %}
                    </div>
                    <div class="row">
                        <div class="cell padded rw-12">
                            <input type="hidden" id="pmidrecipient" value="{{ citizen_id }}">
                            <div id="forum-content">

                            </div>
                        </div>
                    </div>
                </div>
            </div>



        </div>
    </div>
    {% embed "ajax/admin/users/footer.html.twig" %}{% endembed %}
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>
        {% if active %}
            {% if alive %}
                document.getElementById('x-headshot').addEventListener('click', function(e) {
                    e.preventDefault();
                    if (confirm('{{ 'Das Leben dieses Bürgers sofort beenden?'|trans({},'admin') }}'))
                        $.ajax.easySend( '{{ path('admin_users_citizen_headshot', { 'id': user.Id }) }}', [],
                            function () {
                                $.ajax.load(null, '{{ path('admin_users_citizen_view', { 'id': user.Id }) }}', true);
                            } )
                });

                document.getElementById('x-pm').addEventListener('click', function(e) {
                    document.getElementById("forum-content").innerHTML = "";
                    $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('admin_pm_editor_controller', {'type': 'pm'}) }}', false )
                });
            {% elseif is_granted("ROLE_ADMIN") %}
                document.getElementById('x-confirm-death').addEventListener('click', function(e) {
                    e.preventDefault();
                    if (confirm('{{ 'Tod dieses Bürgers zwangsweise bestätigen?'|trans({},'admin') }}'))
                        $.ajax.easySend( '{{ path('admin_users_citizen_confirm_death', { 'id': user.Id }) }}', [],
                            function () {
                                $.ajax.load(null, '{{ path('admin_users_citizen_view', { 'id': user.Id }) }}', true);
                            } )
                });
            {% endif %}
        {% endif %}


    </script>
{% endblock %}

templates/ajax/admin/users/footer.html.twig
<div class="row">
    <div class="cell padded rw-12 rw-sm-12">
        <div id="user-list-wrapper">
            <p>{% trans from 'admin' %}Suche:{% endtrans %} <input type="text" id="user-search" /></p>
            <div id="user-list"></div>
        </div>
    </div>
</div>
{% block js %}
    <script>
        let typingTimer, doneTypingInterval = 500;
        let searchBox = document.getElementById('user-search');

        const userSearchHandler = function() {
            $.ajax.background().load(
                document.getElementById('user-list'),
                '{{ path('admin_users_fuzzyfind') }}',
                false,
                {'name': searchBox.value}
            );
        };

        const userSearchHandlerUp = function () {
            clearTimeout(typingTimer);
            typingTimer = setTimeout(userSearchHandler, doneTypingInterval);
        };

        const userSearchHandlerDown = function () {
            clearTimeout(typingTimer);
        };

        searchBox.addEventListener('keyup', userSearchHandlerUp);
        searchBox.addEventListener('keydown', userSearchHandlerDown);
    </script>
{% endblock %}

templates/ajax/admin/users/index.html.twig
{% extends "ajax/ajax.html.twig" %}
{% block ajax %}
    {% embed "ajax/admin/users/footer.html.twig" %}{% endembed %}
{% endblock %}

templates/ajax/admin/users/list.html.twig
{% block ajax %}
    {% for user in users %}
        <div class="user-list-entry">
        <button x-ajax-href="{{ url('admin_users_citizen_view', {id: user.id}) }}" x-ajax-target="#content" class="button">
            {{ user.username }}
        </button>
        </div>
    {% endfor %}
{% endblock %}

templates/ajax/admin/users/pictos.html.twig
{% extends "ajax/ajax.html.twig" %}
{% block ajax %}
    <div class="row soul">
        <div class="cell padded header rw-12">
            {% embed "ajax/admin/users/tabs.html.twig" %}{% endembed %}
            <div class="row">
                <div class="cell padded rw-12">
                    {{ 'Auszeichnungen'|trans({}, 'admin') }}
                </div>
                {% if is_granted("ROLE_ADMIN") %}
                {% set town = "" %}
                {% set i = 0 %}
                {% for picto in pictos %}
                    {% if i % 3 == 0 %}
                        DEBUT ROW
                    {% endif %}
                    {{ i }}
                    {% if not picto.town is null and picto.town.name != town %}
                        {% set i = i + 1 %}
                        {% set town = picto.town.name %}
                <div class="cell rw-5 rw-sm-12 distinctions">
                    <div class="distinctions-head center">
                        {{picto.town.name}}
                    </div>
                    <div class="distinctions-list center">
                        <div class="overall">
                            {{ '%points% Punkte'|trans({'%points%':0}, 'global') }}
                        </div>
                        <div class="list">
                    {% endif %}
                            <div class="picto{% if picto.prototype.rare %} rare{% endif %}">
                                <img src="{{  asset('build/images/pictos/' ~ picto.prototype.icon ~ '.gif') }}" /><br />
                                <div class="counter">
                                {% for number in picto.count|split('') %}
                                    <span class="count" title="{{number}}">{{number}}</span>
                                {% endfor %}
                                </div>
                                <div class="tooltip">
                                    <h1>{{ picto.prototype.label|trans({}, 'game') }}</h1>
                                    <em>{{ picto.prototype.description|trans({}, 'game')}}</em>
                                </div>
                            </div>
                    {% if loop.index0 == pictos|length - 1 or (not pictos[loop.index].town is null and pictos[loop.index].town.name != picto.town.name) %}
                        </div>
                    </div>
                    <div class="distinctions-foot">
                        &nbsp;
                    </div>
                </div>
                    {% endif %}
                    {% if i>0 and (i-1) % 3 == 2 %}
                        FIN ROW
                    {% endif %}
                {% endfor %}
                {% endif %}
            </div>
        </div>
    </div>
    {% embed "ajax/admin/users/footer.html.twig" %}{% endembed %}
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>
        {% if is_granted("ROLE_ADMIN") %}

        {% endif %}
    </script>
{% endblock %}

templates/ajax/admin/users/tabs.html.twig
<div class="tabs">
    <div class="tab left inline">
        <h4 class="soul-name">
            {{ user.username }}
        </h4>
    </div>
    <div class="tab tab-floater">
        <div class="tab{% if admin_tab == "admin_users_account" %} selected{% endif %}">
            <div class="tab-link" x-ajax-href="{{ path('admin_users_account_view', { 'id': user.Id }) }}">{% trans from 'admin' %}Account{% endtrans %}</div>
        </div>
        <div class="tab{% if admin_tab == "admin_users_ban" %} selected{% endif %}">
            <div class="tab-link" x-ajax-href="{{ path('admin_users_ban_view', { 'id': user.Id }) }}">{% trans from 'admin' %}Verbannung{% endtrans %}</div>
        </div>
        <div class="tab{% if admin_tab == "admin_users_citizen" %} selected{% endif %}">
            <div class="tab-link" x-ajax-href="{{ path('admin_users_citizen_view', { 'id': user.Id }) }}">{% trans from 'admin' %}Bürger{% endtrans %}</div>
        </div>
        <div class="tab{% if admin_tab == "admin_users_pictos" %} selected{% endif %}">
            <div class="tab-link" x-ajax-href="{{ path('admin_users_pictos_view', { 'id': user.Id }) }}">{% trans from 'admin' %}Auszeichnungen{% endtrans %}</div>
        </div>
    </div>

</div>